/************************************************************************************/
/*  Program name CAPFAEXT_ADJUSTMENTS.sql                                          	*/
/*  Creater:  NIP Karen (PCCW - UniHub)                                         	*/
/*************   History   *************************                                */
/* 21 DEC, 2005   NIP Karen         First created                               	*/
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_ADJUSTMENTS';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_ADJUSTMENTS.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_ADJUSTMENTS
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.TRANSACTION_HEADER_ID||CHR(9)||
				C1.SOURCE_TYPE_CODE||CHR(9)||
				C1.ADJUSTMENT_TYPE||CHR(9)||
				C1.DEBIT_CREDIT_FLAG||CHR(9)||
				C1.CODE_COMBINATION_ID||CHR(9)||
				C1.BOOK_TYPE_CODE||CHR(9)||
				C1.ASSET_ID||CHR(9)||
				C1.ADJUSTMENT_AMOUNT||CHR(9)||
				C1.DISTRIBUTION_ID||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
				C1.LAST_UPDATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.ANNUALIZED_ADJUSTMENT||CHR(9)||
				C1.JE_HEADER_ID||CHR(9)||
				C1.JE_LINE_NUM||CHR(9)||
				C1.PERIOD_COUNTER_ADJUSTED||CHR(9)||
				C1.PERIOD_COUNTER_CREATED||CHR(9)||
				C1.ASSET_INVOICE_ID||CHR(9)||
				C1.GLOBAL_ATTRIBUTE1||CHR(9)||
				C1.GLOBAL_ATTRIBUTE2||CHR(9)||
				C1.GLOBAL_ATTRIBUTE3||CHR(9)||
				C1.GLOBAL_ATTRIBUTE4||CHR(9)||
				C1.GLOBAL_ATTRIBUTE5||CHR(9)||
				C1.GLOBAL_ATTRIBUTE6||CHR(9)||
				C1.GLOBAL_ATTRIBUTE7||CHR(9)||
				C1.GLOBAL_ATTRIBUTE8||CHR(9)||
				C1.GLOBAL_ATTRIBUTE9||CHR(9)||
				C1.GLOBAL_ATTRIBUTE10||CHR(9)||
				C1.GLOBAL_ATTRIBUTE11||CHR(9)||
				C1.GLOBAL_ATTRIBUTE12||CHR(9)||
				C1.GLOBAL_ATTRIBUTE13||CHR(9)||
				C1.GLOBAL_ATTRIBUTE14||CHR(9)||
				C1.GLOBAL_ATTRIBUTE15||CHR(9)||
				C1.GLOBAL_ATTRIBUTE16||CHR(9)||
				C1.GLOBAL_ATTRIBUTE17||CHR(9)||
				C1.GLOBAL_ATTRIBUTE18||CHR(9)||
				C1.GLOBAL_ATTRIBUTE19||CHR(9)||
				C1.GLOBAL_ATTRIBUTE20||CHR(9)||
				C1.GLOBAL_ATTRIBUTE_CATEGORY||CHR(9)||
				C1.DEPRN_OVERRIDE_FLAG||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
